<?
/*****
#
# This software may be used and distributed according to the terms
# of the GNU Public License, incorporated herein by reference.
#
# See file COPYING for details of the GNU GPL.
#
#################################
WebNap Client copyright 2000
Aakash Kambuj - aakash@idearing.com
Kalpak Kothari - kalpak@idearing.com
#################################

You are welcome to modify and distribute this code, but you MUST retain
this copyright notice above any notices you put.  If you use this program
beyond personal use, we request that you send us a copy of your modified code.

Napster is a registered trademark of Napster Inc - http://www.napster.com

*****/


include("webnap.inc");
include("Song.class.php");

$error_string = "";

function init_quick_conn($napserver){

  global $server_socket;
  global $message_type_login;
  global $message_type_login_response;
  global $message_type_sysmsg;
  global $mesage_type_stats;
  global $username;
  global $password;
  global $keywords;
  global $error_string;
  
  if (!isset($server_socket)){
    $server_socket=0;
  }

  if ($server_socket<=0){
    $hostarray = explode(":", $napserver);
    $host = $hostarray[0];
    $port = $hostarray[1];
    
    //now we know the hostname and port to connect to
    $server_socket = fsockopen($host, $port, &$errstr, &$errno);     //open a connection to the server
    if (!$server_socket){
      $error_string .= "ERROR $errstr ($errno)<br>\n";
      print_error($error_string);
      exit;
    }

    //now we can send a login packet
    $login_string =  "$username $password 6699 \"v2.0 BETA 6\" 10";
    write_packet($message_type_login, $login_string);
    flush();
    $buffer = read_packet();
    if((int)$buffer[1] != $message_type_login_response) {
      $error_string .= "Unable to login to server. The server may be busy or it might have reached the MAX user limit.";
      print_error($error_string);
      close_conn();
      exit;
    }
    
    do {
      $buffer = read_packet();
    } while ((int)$buffer[1]==$message_type_sysmsg);
  }
}


function getmp3(){

  global $server_socket;
  global $QUERY_STRING;
  global $keywords;
  global $title;
  global $filename;
  global $nick;
  global $error_string;
  global $mpsize;

  //we have already logged in. The find song code can then be called
  //repeatedly

  //First check the connection to the server

  if ($server_socket<=0){
    $error_string .=  "<br>ERROR. Connection failed!\n";
    print_error($error_string);
    close_conn();
    exit;
  }
  
  $title = urldecode("$title");
  $nick = urldecode("$nick");
  
  $temp = strrchr($title, '\\');
  if (!$temp){
    $filename = $title;
  }
  else 
    $filename = substr($temp, 1, strlen($temp)-2);

  download_song();
}

function download_song() {

  global $server_socket;
  global $message_type_fileinfo_req;
  global $message_type_fileinfo;
  global $message_type_get_error;
  global $message_type_sysmsg;
  global $message_type_stats;
  global $username;
  global $rhost;
  global $rport;
  global $title;
  global $filename;
  global $nick;
  global $error_string;

  //send message to server
  $message =  "$nick  ";
  $message .=  "$title";

  write_packet($message_type_fileinfo_req, $message);
  $answer = "";
  $gotreply = 0;
  flush();

  $answer = read_packet();

  while(!$gotreply) {
    if((int)$answer[1]==$message_type_get_error) {
      $error_string .= "<br> Download Error. The remote file you requested to download is unavailable.<br>\n";
      print_error($error_string);
      flush();
      fclose($server_socket);
      exit;
    }
    elseif((int)$answer[1]==$message_type_stats) {
      write_packet($message_type_fileinfo_req, $message);
      $answer = "";
      flush();
      $answer = read_packet();
    }
  elseif((int)$answer[1]==$message_type_sysmsg) {
    while((int)$answer[1]==$message_type_sysmsg)
      $answer = read_packet();
    write_packet($message_type_fileinfo_req, $message);
    $answer = "";
    flush();
    $answer = read_packet();
  }
  elseif((int)$answer[1]!=$message_type_fileinfo) {
    // return if we did not receive download ack
    $error_string .= "<br> Download Error. Did not receive download ACK: $answer[1] $answer[2]<br>\n";
    print_error($error_string);
    flush();
    fclose($server_socket);
    exit;
  }
    else
      $gotreply = 1;
  }

  // server returns the download ack with remote host and port
  $ruser = strtok($answer[2],  " ");
  $rhost = strtok( " ");
  $rport = strtok( " ");


  //Convert the $rhost to quad dotted ip address format
  $rhost = uinttoip($rhost);
  flush();

  if ($rport != 0) {
    download($username,$rhost,$rport,$title,$filename);
    close_conn();
    exit;
  }
  else {
    fdownload($nick,$title,$filename);
    close_conn();
    exit;
  }
}

function download($username,$rhost,$rport,$title,$filename) {
  
  global $error_string;
  global $remote_user;
  $MTU = 15000;
  
  $remote_user = fsockopen($rhost, $rport, &$errstr, &$errno);     //open a connection to the remote user
  if (!$remote_user){
    $error_string .= "<br>ERROR $errstr ($errno)<br>\n";
    print_error($error_string);
    return;
  }

  //read magic character '1'
  $dt = (string)fread($remote_user, 1);
  if ($dt !=  "1") {
    $error_string .= "<br>ERROR Expected magic character '1' from remote user: $dt\n";
    print_error($error_string);
    return;
  }

  fwrite($remote_user, "GET");         // write string "GET"
  flush();
  //send file name to get
  $mess = "$username " . $title . " 0";
  //  echo "String sent to remote client after \"GET\": $mess <br>";
  fwrite($remote_user, $mess);

  //read the size of the mp3 file
  $file_length = "";
  $temp=0;
  for ($i=0;$i<$MTU;$i++){
    $temp = fread($remote_user,1);
    if ($temp< '0' || $temp> '9'){
      break;
    }
    $file_length .= $temp;
  }

  $mpsize = (int)$file_length;
  settype($mpsize,"integer");
  flush();


  if ($mpsize <= 0) {
    $error_string .= "<br>ERROR. Remote user sent an invalid filesize: $mpsize\n";
    print_error($error_string);
    close_conn();
    exit;
  }
  
  $num = pack( "C",$temp);

  // start sending file. indicate browser to download.
  header(  "Content-type: application/octet-stream" );
  header(  "Content-Disposition: attachment; filename=$filename" );
  header(  "Content-Length: $mpsize" );

  echo $num;    //first byte of mp3 file

  $count=1;
  do {
    $received = fread($remote_user, $MTU);
    $count +=$MTU;
    echo $received;
  } while ($count<$mpsize);
  fclose($remote_user);
  return;
}

function fdownload($nick,$title,$filename) {
  // implements firewall download by calling a perl script
  // to listen on a local socket

  global $error_string;
  global $message_type_change_port;
  global $message_type_alt_download_req;
  global $server_socket;
  global $fp, $lport;
  $MTU = 15000;

  if($error_string != "") {
    print_error($error_string);
    close_conn();
    exit;
  }

  $lport = get_freeport();
  if(!$lport) {
    $error_string .= "WebNap has reached the MAX firewall download limit. Try again in a few minutes.<br>\n";
    print_error($error_string);
    close_conn();
    exit;
  }
  write_packet($message_type_change_port, $lport);
  write_packet($message_type_alt_download_req, "$nick $title");
  
  $fp = popen("./firewall.pl $lport", "r");
  if (!$fp) {
    $error_string .= "Couldn't run perl script.<br>\n";
    print_error($error_string);
    close_conn();
    exit;
  }

  $buf = fgets($fp, 8);
  if (!strcmp(substr($buf, 0, 5), "error")) {
    $error_string .= $buf;
    $buf = fgets($fp, 100);
    if(strstr($buf, "bind"))
      $error_string .= $buf . "<br>Another user is currently using firewall download on the same port.<br>";
    elseif(strstr($buf, "alarm"))
      $error_string .= $buf . "<br>The remote user did not send any data. Perhaps the user has logged off or disabled file sharing.";
    elseif(strstr($buf, "response"))
      $error_string .= $buf . "<br>The remote user sent invalid data. Perhaps the file you requested does not exist.";
    print_error($error_string);
    close_conn();
    exit;
  }

  header(  "Content-type: application/octet-stream" );
  header(  "Content-Disposition: attachment; filename=$filename" );
  flush();
  echo $buf;
  while(!feof($fp)) {
    $answer = fread($fp, $MTU);
    echo "$answer";
    flush();
  }
  close_conn();
  return;
}

register_shutdown_function("close_conn");

if (isset($napserver)){
  init_quick_conn($napserver);
  getmp3();
}

?>
